/*
 Name:    Arduino UNO communication.ino
 Created: 19.03.2019
 Author:  Even L, Jarle N, Thomas K

 Edited:     13.04.2021
 Edited by:  Mathias D, Anne V, Maren A
 
 This program recieves data from the "Arduino MEGA communication" and from Camera 6
 via an I2C-bus and transmits it further to the PLS via the serial port. 
*/

#include <Wire.h> //Includes the required library
#include <SoftwareSerial.h>

#define rx 2
#define tx 3

SoftwareSerial Serial5(rx,tx);  //Ditigal input RX TX CAMERA 6
String trainData6 = "";


void setup(){
  Wire.begin(2); //Sets adress for the I2C-bus
  Serial.begin(19200); //Serial communication with baudrate 19200
  Serial5.begin(19200); //Software serial for CAMERA 6
  Wire.onReceive(receiveEvent); //Method for receiving data from I2C-bus
}

void loop(){
  //Read input from CAMERA 6
  if(Serial5.available() > 0){
    char byteRead = Serial5.read();
    trainData6 += byteRead;

    if(trainData6.endsWith("\n")){
      Serial.print(trainData6); //Prints data to PLS
      trainData6 = "";  //New string
    }
  }
}

//Gets called when there is data on the I2C bus
void receiveEvent(int i){
  String data = "";
  
  while(Wire.available() > 0){
    data += (char)Wire.read(); //Adds the chars received to the data string
    //When a whole line is recieved the while loop can be aborted
    if(data.endsWith("\n")){ 
      break;
    }
  }
  
  Serial.print(data); //Prints data to the PLS
}
